Wt: Wt::WSlider Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
Wt::WSlider Class Reference

A horizontal or vertical slider control. More...

`#include <Wt/WSlider.h>`

Inheritance diagram for Wt::WSlider:
[legend]

## Public Types
enum class | TickPosition { TicksAbove = 0x1 , TicksBelow = 0x2 , TicksLeft = 0x1 , TicksRight = 0x2 }
| Enumeration that specifies the location of ticks. More...
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WSlider ()
| Creates a default horizontal slider.
| WSlider (Orientation orientation)
| Creates a default slider of the given orientation.
| ~WSlider ()
| Destructor.
void | setNativeControl (bool nativeControl)
| Configures whether a native HTML5 control should be used.
bool | nativeControl () const
| Returns whether a native HTML5 control is used.
void | setOrientation (Wt::Orientation orientation)
| Sets the slider orientation.
Orientation | orientation () const
| Returns the slider orientation.
void | setTickInterval (int tickInterval)
| Sets the tick interval.
int | tickInterval () const
| Returns the tick interval.
void | setTickPosition (WFlags< TickPosition > tickPosition)
| Sets the tick position.
WFlags< TickPosition > | tickPosition () const
| Returns the tick position.
void | setTickLength (const Wt::WLength &length)
| Sets the length of the ticks to be drawn.
const Wt::WLength & | tickLength () const
| Returns the tick length.
virtual void | setValue (int value)
| Sets the slider value.
int | value () const
| Returns the current slider value.
void | setMaximum (int maximum)
| Sets the maximum value.
int | maximum () const
| Returns the maximum value.
void | setMinimum (int minimum)
| Sets the minimum value.
int | minimum () const
| Returns the minimum value.
void | setRange (int minimum, int maximum)
| Sets the value range.
int | step () const
| Return the step value.
void | setStep (int step)
| Sets the step value.
Signal< int > & | valueChanged ()
| Signal emitted when the user has changed the value of the slider.
JSignal< int > & | sliderMoved ()
| Signal emitted while the user drags the slider.
void | setHandleWidth (int width)
| Sets the slider handle width.
int | handleWidth () const
| Returns the handle width.
EventSignal & | input ()
| Signal emitted when input was captured.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WString | valueText () const override
| Returns the current value.
virtual void | setValueText (const WString &value) override
| Sets the value text.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
Public Member Functions inherited from Wt::WFormWidget
| WFormWidget ()
| Creates a WFormWidget.
| ~WFormWidget ()
| Destructor.
WLabel * | label () const
| Returns the label associated with this widget.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Sets the hidden state of this widget.
void | setValidator (const std::shared_ptr< WValidator > &validator)
| Sets a validator for this field.
virtual std::shared_ptr< WValidator > | validator () const
| Returns the validator.
virtual ValidationState | validate ()
| Validates the field.
void | setEnabled (bool enabled)
| Sets whether the widget is enabled.
virtual void | setReadOnly (bool readOnly)
| Sets the element read-only.
bool | isReadOnly () const
| Returns whether the form element is read-only.
virtual void | setPlaceholderText (const WString &placeholder)
| Sets the placeholder text.
const WString & | placeholderText () const
| Returns the placeholder text.
EventSignal & | changed ()
| Signal emitted when the value was changed.
Signal< WValidator::Result > & | validated ()
| Signal emitted when the widget is being validated.
virtual void | refresh () override
| Refresh the widget.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual int | tabIndex () const override
| Returns the tab index.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Static Public Attributes
static const Wt::WFlags< TickPosition > | NoTicks
| Do not render ticks.
static const Wt::WFlags< TickPosition > | TicksBothSides
| Render ticks on both sides.
Static Public Attributes inherited from Wt::WWidget

## Protected Member Functions
virtual void | paintTick (WPainter &painter, int value, int x, int y)
| Paints a slider ticks (for a non-native widget)
virtual std::unique_ptr< WInteractWidget > | createHandle ()
| Creates the handle (for a non-native widget)
virtual void | layoutSizeChanged (int width, int height) override
| Virtual method that indicates a size change.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WFormWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WInteractWidget
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WFormWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WFormWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A horizontal or vertical slider control.

A slider allows the user to specify an integer value within a particular range using a visual slider.

The slider must be sized explicitly using resize() or by a layout manager. The default size is 150 x 50 pixels for a horizontal slider, and 50 x 150 pixels for a vertical slider.

Usage example:

auto scaleSlider = std::make_unique<Wt::WSlider>(Wt::Orientation::Horizontal);
scaleSlider->setMinimum(0);
scaleSlider->setMaximum(20);
scaleSlider->setValue(10);
scaleSlider->setTickInterval(5);
scaleSlider->setTickPosition(Wt::WSlider::TicksBothSides);
scaleSlider->setTickLength(Wt::WLength(10));
scaleSlider->resize(300, 50);
scaleSlider->valueChanged().connect(this, &ThisClass::scaleShape);
Wt::WLength
A value class that describes a CSS length.
Definition WLength.h:56
Wt::WSlider::TicksBothSides
static const Wt::WFlags< TickPosition > TicksBothSides
Render ticks on both sides.
Definition WSlider.h:68
Wt::Orientation::Horizontal
@ Horizontal
Horizontal.
Horizontal slider with ticks on both sides.

### CSS

The non-native slider (HTML4, see setNativeControl()) is styled by the current CSS theme.

## Member Enumeration Documentation

## ◆ TickPosition

enum class Wt::WSlider::TickPosition
| strong

Enumeration that specifies the location of ticks.

Enumerator
TicksAbove | Render ticks above (horizontal slider)
TicksBelow | Render ticks below (horizontal slider)
TicksLeft | Render ticks on the left side (vertical slider)
TicksRight | Render ticks on the right side (vertical slider)

## Constructor & Destructor Documentation

## ◆ WSlider() [1/2]

Wt::WSlider::WSlider | ( |  | ) |

Creates a default horizontal slider.

The slider shows no ticks, has a range from 0 to 99, and has tickInterval of 0 (defaulting to three ticks over the whole range).

The initial value is 0.

## ◆ WSlider() [2/2]

Wt::WSlider::WSlider | ( | Orientation | orientation | ) |

Creates a default slider of the given orientation.

The slider shows no ticks, has a range from 0 to 99, and has tickInterval of 0 (defaulting to three ticks over the whole range).

The initial value is 0.

## Member Function Documentation

## ◆ createHandle()

virtual std::unique_ptr< WInteractWidget > Wt::WSlider::createHandle | ( |  | ) |
| protectedvirtual

Creates the handle (for a non-native widget)

The default implementation creates a container widget. You may want to specialize this function if you want to have more control on the handle appearance or if you want to associate with the handle a tooltip or other information (e.g. a popup balloon).

## ◆ enableAjax()

virtual void Wt::WSlider::enableAjax | ( |  | ) |
| overridevirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WFormWidget.

## ◆ handleWidth()

int Wt::WSlider::handleWidth | ( |  | ) | const

Returns the handle width.

See also
  setHandleWidth()

## ◆ input()

EventSignal & Wt::WSlider::input | ( |  | ) |

Signal emitted when input was captured.

The signal is only emitted when keyboard input (arrow keys) are captured.

## ◆ layoutSizeChanged()

virtual void Wt::WSlider::layoutSizeChanged | ( | int | width,
|  | int | height )
| overrideprotectedvirtual

Virtual method that indicates a size change.

This method propagates the client-side width and height of the widget when the widget is contained by a layout manager and setLayoutSizeAware(true) was called.

See also
  setLayoutSizeAware()

Reimplemented from Wt::WWidget.

## ◆ maximum()

int Wt::WSlider::maximum | ( |  | ) | const

Returns the maximum value.

See also
  setMaximum(int)

## ◆ minimum()

int Wt::WSlider::minimum | ( |  | ) | const

Returns the minimum value.

See also
  setMinimum(int)

## ◆ nativeControl()

bool Wt::WSlider::nativeControl | ( |  | ) | const

Returns whether a native HTML5 control is used.

Taking into account the preference for a native control, configured using setNativeControl(), this method returns whether a native control is actually being used.

## ◆ orientation()

Orientation Wt::WSlider::orientation | ( |  | ) | const

Returns the slider orientation.

See also
  setOrientation()

## ◆ paintTick()

virtual void Wt::WSlider::paintTick | ( | WPainter & | painter,
|  | int | value,
|  | int | x,
|  | int | y )
| protectedvirtual

Paints a slider ticks (for a non-native widget)

The default implementation draws ticks taking into account the the tickPosition.

The mid point for the tick should be at position (x, y). The `value` that corresponds to the tick is also passed.

## ◆ render()

virtual void Wt::WSlider::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WFormWidget.

## ◆ resize()

virtual void Wt::WSlider::resize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Resizes the widget.

Specifies a fixed size for this widget, setting CSS `width` and `height` properties. By default a widget has automatic width and height, which sets a size for the widget following CSS rules.

When the widget is not managed by a layout manager, the automatic (natural) size of a widget depends on whether they widget is a block or inline widget:

- a block widget takes by default the width of the parent, and the height that it needs based on its contents
- an inline widget takes the width and height that it needs based on its contents (possibly wrapping over multiple lines). The width and height of an inline widget cannot be changed (by the letter of CSS, although most browsers will react to it in varying ways).

When inserted in a layout manager, the size set will be used as a widget's preferred size, but the widget may be given a different size by the layout manager based on available space and stretch factors. The actual size given by a layout manager may be retrieved by making the widget "layout size aware", using setLayoutSizeAware(). If you have defined a `"wtResize()"` JavaScript method for the widget, then this method will also be called.

The default width and height of a widget is WLength::Auto.

See also
  width(), height()

Reimplemented from Wt::WWebWidget.

## ◆ setDisabled()

virtual void Wt::WSlider::setDisabled | ( | bool | disabled | ) |
| overridevirtual

Sets whether the widget is disabled.

Enables or disables the widget (including all its descendant widgets). setDisabled(false) will enable this widget and all descendant widgets that are not disabled. A widget is only enabled if it and all its ancestors in the widget tree are disabled.

Typically, a disabled form widget will not allow changing the value, and disabled widgets will not react to mouse click events.

Note
  enable() and disable() are considered to be stateless slots by default. If you override setDisabled() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

See also
  disable(), enable()

Reimplemented from Wt::WWebWidget.

## ◆ setHandleWidth()

void Wt::WSlider::setHandleWidth | ( | int | width | ) |

Sets the slider handle width.

This sets the width for the handle, which is needed to accurately position the handle.

The default value is 20 pixels.

## ◆ setMaximum()

void Wt::WSlider::setMaximum | ( | int | maximum | ) |

Sets the maximum value.

The maximum value defines the upper limit of the valid range. The lower limit and current value are automatically adjusted to remain valid.

See also
  maximum(), setMinimum(), setRange()

## ◆ setMinimum()

void Wt::WSlider::setMinimum | ( | int | minimum | ) |

Sets the minimum value.

The minimum value defines the lower limit of the valid range. The upper limit and current value are automatically adjusted to remain valid.

See also
  minimum(), setMaximum(), setRange()

## ◆ setNativeControl()

void Wt::WSlider::setNativeControl | ( | bool | nativeControl | ) |

Configures whether a native HTML5 control should be used.

When `native`, the new "range" input element, specified by HTML5 and when implemented by the browser, is used rather than the built-in element. A native control is styled by the browser (usually in sync with the OS) rather than through the theme chosen. Settings like tick interval and tick position are ignored.

Note
  Vertically oriented sliders are in theory supported by the HTML5 input element, but in practice are usually not rendered correctly by the browser.

## ◆ setOrientation()

void Wt::WSlider::setOrientation | ( | Wt::Orientation | orientation | ) |

Sets the slider orientation.

See also
  orientation()

## ◆ setRange()

void Wt::WSlider::setRange | ( | int | minimum,
|  | int | maximum )

Sets the value range.

See also
  setMinimum(), setMaximum()

## ◆ setStep()

void Wt::WSlider::setStep | ( | int | step | ) |

Sets the step value.

This is a positive integer value that indicates by which step the slider moves between the minimum and maximum.

It is not necessary that the slider's range can be neatly divided by the step value. Meaning a range of 50 (0 - 50), with a step of 7, is possible, but will never reach the maximum value.

See also
  step()

## ◆ setTickInterval()

void Wt::WSlider::setTickInterval | ( | int | tickInterval | ) |

Sets the tick interval.

The tick interval specifies the interval for placing ticks along the slider. The interval is specified in value units (not pixel units). A value of 0 specifies an automatic tick interval, which defaults to 3 ticks spanning the whole range.

See also
  tickInterval(), setTickPosition()

## ◆ setTickLength()

void Wt::WSlider::setTickLength | ( | const Wt::WLength & | length | ) |

Sets the length of the ticks to be drawn.

This length will be either the width or height when the slider is oriented vertically or horizontally respectively.

This function has no effect if the native widget is used.

See also
  tickLength()

## ◆ setTickPosition()

void Wt::WSlider::setTickPosition | ( | WFlags< TickPosition > | tickPosition | ) |

Sets the tick position.

The tick position indicates if and where ticks are placed around the slider groove.

This function has no effect if the native widget is used.

See also
  tickPosition(), setTickInterval()

## ◆ setValue()

virtual void Wt::WSlider::setValue | ( | int | value | ) |
| virtual

Sets the slider value.

The value is automatically trimmed to the valid range (minimum() to maximum()).

See also
  value()

## ◆ setValueText()

virtual void Wt::WSlider::setValueText | ( | const WString & | value | ) |
| overridevirtual

Sets the value text.

This sets the current value from a string value.

Implements Wt::WFormWidget.

## ◆ sliderMoved()

JSignal< int > & Wt::WSlider::sliderMoved | ( |  | ) |

Signal emitted while the user drags the slider.

The current dragged position is passed as the argument. Note that the slider value is not changed while dragging the slider, but only after the slider has been released.

See also
  valueChanged()

## ◆ step()

int Wt::WSlider::step | ( |  | ) | const

Return the step value.

The default value of the step is `1`.

See also
  setStep(int)

## ◆ tickInterval()

int Wt::WSlider::tickInterval | ( |  | ) | const

Returns the tick interval.

See also
  setTickInterval()

## ◆ tickLength()

const Wt::WLength & Wt::WSlider::tickLength | ( |  | ) | const

Returns the tick length.

See also
  setTickLength()

## ◆ tickPosition()

WFlags< TickPosition > Wt::WSlider::tickPosition | ( |  | ) | const

Returns the tick position.

See also
  setTickPosition(), setTickInterval()

## ◆ value()

int Wt::WSlider::value | ( |  | ) | const

Returns the current slider value.

See also
  setValue()

## ◆ valueChanged()

Signal< int > & Wt::WSlider::valueChanged | ( |  | ) |

Signal emitted when the user has changed the value of the slider.

The new value is passed as the argument.

See also
  sliderMoved()

## ◆ valueText()

virtual WString Wt::WSlider::valueText | ( |  | ) | const
| overridevirtual

Returns the current value.

This returns the current value as a string.

Implements Wt::WFormWidget.